#include<iostream>

#include<vector>
#include<algorithm>
#include<map>
#include<set>
#include<list>
#include<stack>
#include<queue>

#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<string.h>

using namespace std;

#define FOR(i,a,b) for(int i=a;i<=b;i++)

#define PB push_back
#define PII pair<int,int>
#define PLL pair<ll,ll>
#define MP make_pair
#define fi first
#define se second

#define SIZE(s) (int) (s).size()

#define INF 987654321
#define ll long long

#define MAX 2000047
#define MAX2 1047

int jump[MAX2];

char p[MAX2];
char text[MAX];
int N,M;

void kmp_init()
{
	int i,j;
	jump[0] = -1;
	for(i=0,j=-1;i<M;i++, j++,jump[i]=j)
	{
		while((j >= 0) && (p[i] != p[j]))
			j = jump[j];
	}
}

int vyskyt[MAX];
int hist[MAX];
int poses[MAX];
int range[MAX];
bool done_poses;

void kmp_search()
{
	int i,j;

	for(i=0,j=0; j<M &&  i<N; i++, j++)
	{
		while((j>=0) && (text[i]!=p[j]))
		{
			cout << hist[i] << " " << i << endl;
			j = jump[j];
		}
		done_poses = false;
		if (j==M-1)
		{
			cout << j << " " << i << endl;
			//vyskyt
			//j=jump[j];
			j = hist[poses[i-1]];
			range[i] = 2;
			range[poses[i-1]] = 1;
			poses[i] = poses[i-M];
			done_poses = true;
			//cout << j << endl;
		}
		
		hist[i] = j;
		if (j >= 0 && j < M-1 && !done_poses)  {
			if (j == 0) {
				poses[i] = i;
			} else {
				if (hist[i] > hist[i-1]) poses[i] = poses[i-1];
			}
		}
		cout << "hist " << i << ": " << j << "  poses " << i << ": " << poses[i] << endl;

	}
}

//----------------------

// N = dlzka textu
// M = dlzka vzoru
// text = text
// p = vzor

int main()
{
	int q;
	char c;
	while(scanf("%d %s",&q,p) == 2)
	{
		M = (int) strlen(p);
		cout<< "---------------- VZOR: " << p << endl;
		getchar();
		
		FOR(i,0,M-1) jump[i] = 0;
		kmp_init();
		//FOR(i,0, M-1) printf("jump %d: %d\n", i, jump[i]);

		while(q--)
		{
			int i=0;
			while((c=getchar()) != '\n')
			{
				text[i++] = c;
			}
			text[i] = '\0';
			N = i;
			puts(text);
			//cout << N << endl;

			FOR(i,0,N-1) {
				vyskyt[i] = 0;
				hist[i] = 0;
				poses[i] = 0;
				range[i] = 0;
			}

			kmp_search();

			int count = 0;
			FOR(i,0,N-1) {
				if (range[i] == 1) count++;
				if (range[i] == 2) {
					count--;
				} else if (count == 0) putchar(text[i]);
			}
			putchar('\n');

			FOR(i,0,N-1) cout << "range " << i << ": " << range[i] << endl;

		//	puts(p);
		}
	}

	return 0;
}
 
